CREATE TABLE public.users
(
    "UserID" character varying(10)[] NOT NULL,
    "ActiveDirectoryAuth" boolean NOT NULL DEFAULT false,
    "Name" character varying(250) NOT NULL DEFAULT '',
    "Surname" character varying(250) NOT NULL DEFAULT '',
    "Email" character varying(500) NOT NULL DEFAULT '',
    "Password" character varying(255) NOT NULL DEFAULT '',
    "PrivateKey" text COLLATE,
    "CreationDate" timestamp without time zone NOT NULL DEFAULT NOW(),
    "LastChanged" timestamp without time zone NOT NULL DEFAULT NOW(),
    "StatusFlag" smallint NOT NULL,
    PRIMARY KEY ("UserID")
);

ALTER TABLE IF EXISTS public.users
    OWNER to postgres;

COMMENT ON TABLE public.users
    IS 'Table containing user information';

COMMENT ON COLUMN public.users."PrivateKey"
    IS 'Private Key of the user with which the user can sign things';